#!/usr/bin/perl
# indexsoft mysql backups manager
# http://www.indexsoft.com

require "./backupsmanager.pm";

$|++;
&ReadParameters();
$VER = '1.02 shareware';

if ($P{'db'} =~ /^\d+$/)
{
	$DB = $P{'db'};
	$mySQLDBName = $mySQLDBName[$DB];
	$mySQLHost = $mySQLHost[$DB];
	$mySQLUser = $mySQLUser[$DB];
	$mySQLPassword = $mySQLPassword[$DB];
	$DumpDBCommand = "$DumpDBCommand --host=$mySQLHost --user=$mySQLUser --password=$mySQLPassword --add-drop-table $mySQLDBName";
	$RestoreDBCommand = "$RestoreDBCommand --host=$mySQLHost --user=$mySQLUser --password=$mySQLPassword $mySQLDBName";
	$DBDumpsDir = "$DBDumpsDir$DirSeparator$mySQLHost---$mySQLDBName";
	if ($mySQLDBName) { mkdir ($DBDumpsDir, '0777'); chmod (0777, $DBDumpsDir); }
}

print &TopOfPage();
if (($P{'todo'} eq 'checkver'))
{
	print qq{<p><iframe src="http://www.indexsoft.com/checkver.px?program=backupsmanager&ver=$VER" width="550" height="100" marginwidth="0" marginheight="0" scrolling="no" frameborder="0"><p>Please visit <a href="http://www.indexsoft.com/dbmanagerpro/" target="_top">home page of <i>indexsoft MySQL backups manager</i></a> to check new version.</p><br><br><br></iframe></p><p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>};
}
elsif (($P{'todo'} eq 'restore') and $P{'filename'} and $mySQLDBName)
{
	print qq{<p></p><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Database is restored!\\nYou still use shareware version.\\nPlease register!');\n//-->\n</SCRIPT>};
	print "<p><b>Operation:</b> restore database <i>'$mySQLDBName'</i> from backup <i>'$P{'filename'}'</i></p>";
	$code = system "$RestoreDBCommand <\"$DBDumpsDir$DirSeparator$P{'filename'}\"";
	&HoldError("Command <i>$RestoreDBCommand <\"$DBDumpsDir$DirSeparator$P{'filename'}\" executed with error</i>") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'delete') and $P{'files'} and $mySQLDBName)
{
	print "<p><b>Operation:</b> delete selected backups.</p>";
	foreach $file(split(/\0/, $P{'files'}))
	{
		unlink ("$DBDumpsDir$DirSeparator$file") || &HoldError("Can not delete file<i>'$DBDumpsDir$DirSeparator$file'</i>");
	}
	print &ManageForm();
}
elsif (($P{'todo'} eq 'upload') and $P{'uploadfilename'} and $mySQLDBName)
{
	$filehandle = $MULTIPARTQUERY->param('uploadfilename');
	$filename = lc($P{'uploadfilename'});
	$filename =~ s!^.*(\\|\/)!!; 
	print "<p><b>Operation:</b> upload backup <i>'$filename'</i></p>";
	open(OUT, ">$DBDumpsDir$DirSeparator$filename") || &HoldError("Can not save to file <i>'$DBDumpsDir$DirSeparator$filename'</i>");
	binmode OUT;
	while (read($filehandle, $buffer, 1024))
	{
		print OUT $buffer;
	}
	close OUT;
	print &ManageForm();
}
elsif (($P{'todo'} eq 'downloadfile') and $P{'file'})
{
	print qq{<p><b>This feature disabled on shareware version. <a href="http://www.indexsoft.com/dbmanagerpro/">Please register</a>.</b></p><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>};
	print &ManageForm();
}
elsif ($P{'todo'} eq 'dumpanddownload' and $mySQLDBName)
{
	print qq{<p><b>This feature disabled on shareware version. <a href="http://www.indexsoft.com/dbmanagerpro/">Please register</a>.</b></p><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>};
	print &ManageForm();
}
elsif ($P{'todo'} eq 'dumpandsave' and $mySQLDBName)
{
	if (!$P{'filename'}) { $filename = &TextDate(time).'.sql' } else { $filename = $P{'filename'} };
	print "<p><b>Operation:</b> backup database <i>'$mySQLDBName'</i> and save backup to file <i>'$filename'</i></p>";
	$code = system "$DumpDBCommand >\"$DBDumpsDir$DirSeparator$filename\"";
	&HoldError("Command <i>$DumpDBCommand >\"$DBDumpsDir$DirSeparator$filename\" executed with error</i>") if ($code);
	print &ManageForm();
}
else
{
	print &ManageForm();
}
print &BottomOfPage();

#################################################################################
sub ManageForm
{
	my $filename = &TextDate(time).'.sql';
	my ($result, $dbselect, $i) = ('','','');
	for ($i = 0; $i <= $#mySQLDBName; ++$i)	{ $dbselect .= qq{<option value="$i"}.(($DB eq $i)?' selected style="background-color: #FFFFFF;">':'>').qq{DB$i: $mySQLDBName[$i] (user $mySQLUser[$i] at $mySQLHost[$i])}; }
	my $result = qq{
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Select database for maintenance
	</td></tr></table></td></tr></table>
	<p><form name="selectdbform" action="backupsmanager.cgi">
	<select name="db" style="background-color: #E0E0E0;">$dbselect</select><br><br>
	<input type="submit" value="select database">
	</form></p>};
	return $result if !$mySQLDBName;
	$result .= qq{<p><form name="makedbdumpform" action="backupsmanager.cgi" method="post" target="_top">
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Backup database <i>'$mySQLDBName'</i>
	</td></tr></table></td></tr></table>
	<input type="hidden" name="db" value="$DB">
	<ul>
	<li><input type="radio" checked name="todo" value="dumpandsave" onclick="filename.disabled = false; makedbdumpform.target = '_self'; "> backup and save it to file: <input type="text" name="filename" value="$filename"><br>
	<li><input type="radio" name="todo" value="dumpanddownload" onclick="filename.disabled = true; makedbdumpform.target = '_top'; "> backup and download it to my computer<br>
	</ul>
	<input type="submit" value="Backup">
	</form></p>
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	function AreYouSure()
	{
		if (selectdbdumpform.todo.value == 'restore') { return window.confirm('You about to restore database \\'$mySQLDBName\\' from backup.\\nAre you shure?') }
		else { return true; }
	}
	function Boxes(z)
	{
		if (z == 'delete')
		{
			selectdbdumpform.todo.value = 'delete';
			selectdbdumpform.submit.value = 'Delete backups';
			selectdbdumpform.submit.disabled = false;
			for (var i=0;i<document.selectdbdumpform.elements.length;i++) { var z=document.selectdbdumpform.elements[i]; if (z.name == 'filename') { z.checked = false } }
		}
		else
		{
			selectdbdumpform.todo.value = 'restore';
			selectdbdumpform.submit.value = 'Restore from backup';
			selectdbdumpform.submit.disabled = false;
			for (var i=0;i<document.selectdbdumpform.elements.length;i++) { var z=document.selectdbdumpform.elements[i]; if (z.name == 'files') { z.checked = false } }
		}
	}
	//-->
	</SCRIPT>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Select backups of database <i>'$mySQLDBName'</i> to restore or delete
	</td></tr></table></td></tr></table>
	<p><form name="selectdbdumpform" action="backupsmanager.cgi" method="post" onsubmit="return AreYouSure()">
	<input type="hidden" name="db" value="$DB">
	<input type="hidden" name="todo" value="">
	<ul>};
	opendir (DIR, $DBDumpsDir);
	while ($file = readdir(DIR))
	{
		($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$DBDumpsDir$DirSeparator$file");
		$mtime = TextDateTime($mtime);
		$result .= qq{<li><input type="checkbox" name="files" value="$file" title="select for delete" onclick="Boxes('delete')"> | <input type="radio" name="filename" value="$file" title="select for restore" onclick="Boxes('restore')"> | <a target="_top" title="download file" href="backupsmanager.cgi?todo=downloadfile&file=$file&db=$DB&r=}.rand(2).qq{">$file</a> <i>($mtime; size: $size bytes)</i>} if ($file ne '.' and $file ne '..')
	}
	closedir(DIR);
	$result .= qq{
	</ul>
	<input type="submit" name="submit" value="  first select action  " disabled></form></p>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>
	Upload backup for database <i>'$mySQLDBName'</i>
	</td></tr></table></td></tr></table>
	<p><form name="uploaddbdumpform" action="backupsmanager.cgi" method="post" enctype="multipart/form-data">
	<input type="hidden" name="db" value="$DB">
	<input type="hidden" name="todo" value="upload">
	<input type="file" name="uploadfilename" size="50"><br><br>
	<input type="submit" value="Upload backup">
	</form></p>};
	return $result;
}

sub TopOfPage
{
	return qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\n\n<html>
	<head>
	<title>indexsoft MySQL backups manager (ver. $VER)</title>
	<style type="text/css">
		body,p,input,td { font-size : 13px; color : Black; font-family : Arial, Helvetica, sans-serif; }
		p { margin-top : 0px; margin-bottom : 5px; }
		H4 { color : #5588BB; }
		body a { text-decoration : none; }
		body a:hover { text-decoration : underline; }
		body .small { font-size : 11px; text-align: right;}
		body .small2 { font-size : 11px; text-align: left;}
	</style>
	</head>
	
	<body bgcolor="White">
	<center>
	<table width="600" border="0" cellspacing="0" cellpadding="0"><tr><td>
	<center>
	<h4>indexsoft MySQL backups manager (shareware)</h4>
	<p><a href="http://www.indexsoft.com/dbmanagerpro/">register shareware</a></p>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table bgcolor="#ffffff" width="100%" border="0" cellspacing="0" cellpadding="5"><tr><td>};
}

sub BottomOfPage
{
	return qq{</td></tr></table></td></tr></table><div class=small><a href="backupsmanager.cgi?todo=checkver&db=$DB">check new version</a> | <a href="http://www.indexsoft.com">www.indexsoft.com</a></div>
	<!------- Start of HTML Code ------->
	<form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST"><input type="hidden" name="ID" value="16662"><table BORDER="0" CELLSPACING="0" bgcolor="#800000"><tr><td><table border="0" cellspacing="0" width="100%" bgcolor="#EFEFEF" cellpadding="3"><tr><td align="center"><font face="arial, verdana" size="2"><b>Rate Our Script @
	<a href="http://www.hotscripts.com">HotScripts.com</a></b></font></td><td align="center"><select name="ex_rate" size="1"><option selected>Select</option><option value="5" selected>Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select></td><td align="center"><input type="submit" value="Go!"></td></tr></table></td></tr></table></form>
	<!------- End of HTML Code ------->
	<!-- --------- Start of ScriptSearch Rating Code --------- -->
	<form action="http://www.scriptsearch.com/cgi-bin/rateit.cgi" method="post" target="_new">
	<input type="hidden" name="ID" value="5691">
	<table border="0" cellspacing="0">
	<tr><td align="center">
	<font face="arial, verdana" size="2"><b>please rate it! @ 
	<i><a href="http://www.scriptsearch.com/details/5691.html">ScriptSearch.com</a>
	</i></b></font></td></tr>
	<tr><td align=center>
	<select name="rate" size="1" style="font-size:10px;">
	<option value="--">- Select -</option>
	<option value="5" selected>Excellent!</option>
	<option value="4">Very Good</option>
	<option value="3">Good</option>
	<option value="2">Fair</option>
	<option value="1">Poor</option>
	</select> 
	<input type="submit" value="Vote!" style="font-size:10px;">
	</td></tr></table>
	</form>
	<!-- --------- End of ScriptSearch Rating Code --------- -->
	<hr size="1" noshade>
	<p><font size="1">(note: rating forms removed from full version)</font></p>
	</td></tr></table></body></html>};
}

sub HoldError
{
	print "<p><b style=\"color: #DC143C;\">Error:</b> @_[0]</p>\n";
}

sub TextDate
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	$year = 1900+$year;
	++$mon;
	if (length($mon)==1) {$mon="0$mon"};
	if (length($mday)==1) {$mday="0$mday"};
	$_ = "$year-$mon-$mday";
}

sub TextDateTime
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	my(@mons) = ('January', 'February', 'March', 'April', 'May', 'June', 'Jule', 'August', 'September', 'October', 'November', 'December');
	$year = 1900+$year;
	$_ = "$mday $mons[$mon] $year; $hour\:$min\:$sec";
}

sub ReadParameters
{
	use CGI;
	$MULTIPARTQUERY = new CGI;
	my @params = $MULTIPARTQUERY->param;
	my ($line);
	foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); }
}

